// var res = "";
function findNumbers(str, scheme) {
	var numbers = [];
	var location = str.indexOf(scheme);
	// res = res + "input: " + str + "\n";
	// res = res + "looking for: " + scheme + "\n";
	while(location != -1) {
		location = location + scheme.length;
		var noscheme = str.substr(location+1);
		var numberLength = noscheme.indexOf('/');
		numbers.push(parseInt(noscheme.substr(0, numberLength)));
		// res = res + noscheme.substr(0, numberLength) + "\n";
		location = str.indexOf(scheme, location+numberLength);
	}
	return numbers;
}

function findNumber(str, scheme) {
	var numbers = findNumbers(str, scheme);
	if(numbers.length == 1) {
		return numbers[0];
	}
	return -1;
}

// Note: It's important to set srcset before src. If they contain the same URL the non-blocking of src can trigger a still blocked srcset URL to be loaded before it's non-blocked (triggering a detail to be added). This triggers an incorrect detail to be generated (there are other and probably more robust ways to solve this though).
function loadResources(scheme, idSet) {
	var imgElements = document.getElementsByTagName('img');
	var blockScheme = "block-" + scheme;

	// img
	for(var i=0; i<imgElements.length; i++) {
		var str = "";

		// srcset
		if(str = imgElements[i].srcset) {
			// res = res + str + "\n";
			var numbers = findNumbers(str, blockScheme, idSet);
			for(var j=0; j<numbers.length; j++) {
				if(idSet.has(numbers[j])) {
					str = str.replace(blockScheme+":"+numbers[j]+"/", scheme+":"+numbers[j]+"/");
				}
			}
			if(numbers.length > 0) {
				imgElements[i].srcset = str;
				// res = res + imgElements[i].srcset + "\n";
			}
		}

		// src
		if(str = imgElements[i].src) {
			// res = res + str + "\n";
			var number = findNumber(str, blockScheme);
			if(idSet.has(number)) {
				// res = res + "ready to replace: " + (blockScheme+":"+number+"/") + "\n";
				imgElements[i].src = str.replace(blockScheme+":"+number+"/", scheme+":"+number+"/");
				// res = res + imgElements[i].src + "\n";
			}
		}
	}

	// style="background-image: url();"
	var styledElements = document.querySelectorAll("*[style]");
	for(var i=0;i<styledElements.length;i++) {
		if(styledElements[i].style) {
			if(str = styledElements[i].style.backgroundImage) {
				// res = res + str + "\n";
				var number = findNumber(str, blockScheme);
				if(idSet.has(number)) {
					styledElements[i].style.backgroundImage = str.replace(blockScheme+":"+number+"/", scheme+":"+number+"/");
					// res = res + styledElements[i].style.backgroundImage + "\n";
				}
			}
		}
	}

	// return res;
}
